/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include "optest/optest.pmh"

using namespace fe;

void RecordOp::initialize(void)
{
	catalog<String>("icon")="FE_alpha";

	catalog<String>("savefile")="";
	catalog<String>("savefile","label")="Save File";

	catalog<String>("loadfile")="";
	catalog<String>("loadfile","label")="Load File";

	catalog< sp<Component> >("Input Surface");
}

void RecordOp::handle(Record& a_rSignal)
{
	const String savefile=catalog<String>("savefile");
	const String loadfile=catalog<String>("loadfile");

	if(!savefile.empty())
	{
		sp<SurfaceAccessibleI> spInputAccessible;
		if(!access(spInputAccessible,"Input Surface")) return;

		sp<SurfaceAccessibleBase> spSurfaceAccessibleBase=
				registry()->create("*.SurfaceAccessibleBase");

		sp<Scope> spInputScope=registry()->create("Scope");

		spSurfaceAccessibleBase->bind(spInputScope);
		spSurfaceAccessibleBase->copy(spInputAccessible);
		spSurfaceAccessibleBase->save(savefile);
	}

	if(!loadfile.empty())
	{
		sp<SurfaceAccessibleI> spOutputAccessible;
		if(!accessOutput(spOutputAccessible,a_rSignal)) return;

		sp<SurfaceAccessibleBase> spSurfaceAccessibleBase=
				registry()->create("*.SurfaceAccessibleBase");

		sp<Scope> spOutputScope=registry()->create("Scope");

		spSurfaceAccessibleBase->bind(spOutputScope);
		spSurfaceAccessibleBase->load(loadfile);

		spOutputAccessible->copy(spSurfaceAccessibleBase);
	}
}
